/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gameRules;

/**
 *
 * @author dfoxpro
 */
public class Skill {

    private String name;
    private int abilityMod;
    private String abilityModName;
    private int trained;
    private int armorPenality;
    private int miscelanious;
    private boolean editable;
    private PlayerCharacter pc;

    public Skill(String name, String mod, PlayerCharacter arg) {
        this.name = name;
        this.pc = arg;
        this.editable = false;
        this.abilityMod = 0;
        this.trained = 0;
        this.armorPenality = 0;
        this.miscelanious = 0;
        this.abilityModName = mod;
        setAbilityMod(mod);
    }

    public Skill(PlayerCharacter arg) {
        this.pc = arg;
    }

    public Skill() {
    }

    public PlayerCharacter getPj() {
        return pc;
    }

    public void setPj(PlayerCharacter pj) {
        this.pc = pj;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public int getArmorPenality() {
        return armorPenality;
    }

    public void setArmorPenality(int arg) {
        this.armorPenality = arg;
    }

    public boolean getEditable() {
        return editable;
    }

    public void setEditable(boolean editable) {
        this.editable = editable;
    }

    public int getMiscelanious() {
        return miscelanious;
    }

    public void setMiscelanious(int arg) {
        this.miscelanious = arg;
    }

    public int getTrained() {
        return trained;
    }

    public void setTrained(int trained) {
        this.trained = trained;
    }

    public void setEditable(String arg) {
        Skill skl = null;
        if (arg.equals("Acrobatics")) {
            skl = pc.getSkills().get(0);
            skl.setEditable(true);
        } else if (arg.equals("Arcana")) {
            skl = pc.getSkills().get(1);
            skl.setEditable(true);
        } else if (arg.equals("Athletics")) {
            skl = pc.getSkills().get(2);
            skl.setEditable(true);
        } else if (arg.equals("Bluff")) {
            skl = pc.getSkills().get(3);
            skl.setEditable(true);
        } else if (arg.equals("Diplomacy")) {
            skl = pc.getSkills().get(4);
            skl.setEditable(true);
        } else if (arg.equals("Dungeoneering")) {
            skl = pc.getSkills().get(5);
            skl.setEditable(true);
        } else if (arg.equals("Endurance")) {
            skl = pc.getSkills().get(6);
            skl.setEditable(true);
        } else if (arg.equals("Heal")) {
            skl = pc.getSkills().get(7);
            skl.setEditable(true);
        } else if (arg.equals("History")) {
            skl = pc.getSkills().get(8);
            skl.setEditable(true);
        } else if (arg.equals("Insight")) {
            skl = pc.getSkills().get(9);
            skl.setEditable(true);
        } else if (arg.equals("Intimidate")) {
            skl = pc.getSkills().get(10);
            skl.setEditable(true);
        } else if (arg.equals("Nature")) {
            skl = pc.getSkills().get(11);
            skl.setEditable(true);
        } else if (arg.equals("Perception")) {
            skl = pc.getSkills().get(12);
            skl.setEditable(true);
        } else if (arg.equals("Religion")) {
            skl = pc.getSkills().get(13);
            skl.setEditable(true);
        } else if (arg.equals("Stealth")) {
            skl = pc.getSkills().get(14);
            skl.setEditable(true);
        } else if (arg.equals("Streetwise")) {
            skl = pc.getSkills().get(15);
            skl.setEditable(true);
        } else if (arg.equals("Thievery")) {
            skl = pc.getSkills().get(16);
            skl.setEditable(true);
        }
    }

    public void setMiscelaneous(String arg, int i) {
        Skill skl = null;
        if (arg.equals("Acrobatics")) {
            skl = pc.getSkills().get(0);
            skl.setMiscelanious(i);
        } else if (arg.equals("Arcana")) {
            skl = pc.getSkills().get(1);
            skl.setMiscelanious(i);
        } else if (arg.equals("Athletics")) {
            skl = pc.getSkills().get(2);
            skl.setMiscelanious(i);
        } else if (arg.equals("Bluff")) {
            skl = pc.getSkills().get(3);
            skl.setMiscelanious(i);
        } else if (arg.equals("Diplomacy")) {
            skl = pc.getSkills().get(4);
            skl.setMiscelanious(i);
        } else if (arg.equals("Dungeoneering")) {
            skl = pc.getSkills().get(5);
            skl.setMiscelanious(i);
        } else if (arg.equals("Endurance")) {
            skl = pc.getSkills().get(6);
            skl.setMiscelanious(i);
        } else if (arg.equals("Heal")) {
            skl = pc.getSkills().get(7);
            skl.setMiscelanious(i);
        } else if (arg.equals("History")) {
            skl = pc.getSkills().get(8);
            skl.setMiscelanious(i);
        } else if (arg.equals("Insight")) {
            skl = pc.getSkills().get(9);
            skl.setMiscelanious(i);
        } else if (arg.equals("Intimidate")) {
            skl = pc.getSkills().get(10);
            skl.setMiscelanious(i);
        } else if (arg.equals("Nature")) {
            skl = pc.getSkills().get(11);
            skl.setMiscelanious(i);
        } else if (arg.equals("Perception")) {
            skl = pc.getSkills().get(12);
            skl.setMiscelanious(i);
        } else if (arg.equals("Religion")) {
            skl = pc.getSkills().get(13);
            skl.setMiscelanious(i);
        } else if (arg.equals("Stealth")) {
            skl = pc.getSkills().get(14);
            skl.setMiscelanious(i);
        } else if (arg.equals("Streetwise")) {
            skl = pc.getSkills().get(15);
            skl.setMiscelanious(i);
        } else if (arg.equals("Thievery")) {
            skl = pc.getSkills().get(16);
            skl.setMiscelanious(i);
        }
    }

    public void setTrained(String arg) {
        Skill skl = null;
        if (arg.equals("Acrobatics")) {
            skl = pc.getSkills().get(0);
            skl.setTrained(5);
        } else if (arg.equals("Arcana")) {
            skl = pc.getSkills().get(1);
            skl.setTrained(5);
        } else if (arg.equals("Athletics")) {
            skl = pc.getSkills().get(2);
            skl.setTrained(5);
        } else if (arg.equals("Bluff")) {
            skl = pc.getSkills().get(3);
            skl.setTrained(5);
        } else if (arg.equals("Diplomacy")) {
            skl = pc.getSkills().get(4);
            skl.setTrained(5);
        } else if (arg.equals("Dungeoneering")) {
            skl = pc.getSkills().get(5);
            skl.setTrained(5);
        } else if (arg.equals("Endurance")) {
            skl = pc.getSkills().get(6);
            skl.setTrained(5);
        } else if (arg.equals("Heal")) {
            skl = pc.getSkills().get(7);
            skl.setTrained(5);
        } else if (arg.equals("History")) {
            skl = pc.getSkills().get(8);
            skl.setTrained(5);
        } else if (arg.equals("Insight")) {
            skl = pc.getSkills().get(9);
            skl.setTrained(5);
        } else if (arg.equals("Intimidate")) {
            skl = pc.getSkills().get(10);
            skl.setTrained(5);
        } else if (arg.equals("Nature")) {
            skl = pc.getSkills().get(11);
            skl.setTrained(5);
        } else if (arg.equals("Perception")) {
            skl = pc.getSkills().get(12);
            skl.setTrained(5);
        } else if (arg.equals("Religion")) {
            skl = pc.getSkills().get(13);
            skl.setTrained(5);
        } else if (arg.equals("Stealth")) {
            skl = pc.getSkills().get(14);
            skl.setTrained(5);
        } else if (arg.equals("Streetwise")) {
            skl = pc.getSkills().get(15);
            skl.setTrained(5);
        } else if (arg.equals("Thievery")) {
            skl = pc.getSkills().get(16);
            skl.setTrained(5);
        }
    }

    public int getAbilityMod() {
        return abilityMod;
    }

    public void setAbilityMod(String arg) {
        if (arg.equals("str")) {
            abilityMod = pc.scoreModifier(pc.getStr()) + (pc.getLvl() / 2);
        }
        if (arg.equals("con")) {
            abilityMod = pc.scoreModifier(pc.getCon()) + (pc.getLvl() / 2);
        }
        if (arg.equals("dex")) {
            abilityMod = pc.scoreModifier(pc.getDex()) + (pc.getLvl() / 2);
        }
        if (arg.equals("int")) {
            abilityMod = pc.scoreModifier(pc.getInte()) + (pc.getLvl() / 2);
        }
        if (arg.equals("wis")) {
            abilityMod = pc.scoreModifier(pc.getWis()) + (pc.getLvl() / 2);
        }
        if (arg.equals("cha")) {
            abilityMod = pc.scoreModifier(pc.getCha()) + (pc.getLvl() / 2);
        }
    }

    void initSkills() {
        pc.getSkills().add(new Skill("Acrobatics", "dex", pc));   //0
        pc.getSkills().add(new Skill("Arcana", "int", pc));       //1
        pc.getSkills().add(new Skill("Athletics", "str", pc));    //2
        pc.getSkills().add(new Skill("Bluff", "cha", pc));        //3
        pc.getSkills().add(new Skill("Diplomacy", "cha", pc));    //4
        pc.getSkills().add(new Skill("Dungeoneering", "wis", pc));//5
        pc.getSkills().add(new Skill("Endurance", "con", pc));    //6
        pc.getSkills().add(new Skill("Heal", "wis", pc));         //7
        pc.getSkills().add(new Skill("History", "int", pc));      //8
        pc.getSkills().add(new Skill("Insight", "wis", pc));      //9
        pc.getSkills().add(new Skill("Intimidate", "cha", pc));   //10
        pc.getSkills().add(new Skill("Nature", "wis", pc));       //11
        pc.getSkills().add(new Skill("Perception", "wis", pc));   //12
        pc.getSkills().add(new Skill("Religion", "int", pc));     //13
        pc.getSkills().add(new Skill("Stealth", "dex", pc));      //14
        pc.getSkills().add(new Skill("Streetwise", "cha", pc));   //15
        pc.getSkills().add(new Skill("Thievery", "dex", pc));     //16
    }

    void purgeSkills() {
        pc.getSkills().set(0, new Skill("Acrobatics", "dex", pc));   //0
        pc.getSkills().set(1, new Skill("Arcana", "int", pc));       //1
        pc.getSkills().set(2, new Skill("Athletics", "str", pc));    //2
        pc.getSkills().set(3, new Skill("Bluff", "cha", pc));        //3
        pc.getSkills().set(4, new Skill("Diplomacy", "cha", pc));    //4
        pc.getSkills().set(5, new Skill("Dungeoneering", "wis", pc));//5
        pc.getSkills().set(6, new Skill("Endurance", "con", pc));    //6
        pc.getSkills().set(7, new Skill("Heal", "wis", pc));         //7
        pc.getSkills().set(8, new Skill("History", "int", pc));      //8
        pc.getSkills().set(9, new Skill("Insight", "wis", pc));      //9
        pc.getSkills().set(10, new Skill("Intimidate", "cha", pc));   //10
        pc.getSkills().set(11, new Skill("Nature", "wis", pc));       //11
        pc.getSkills().set(12, new Skill("Perception", "wis", pc));   //12
        pc.getSkills().set(13, new Skill("Religion", "int", pc));     //13
        pc.getSkills().set(14, new Skill("Stealth", "dex", pc));      //14
        pc.getSkills().set(15, new Skill("Streetwise", "cha", pc));   //15
        pc.getSkills().set(16, new Skill("Thievery", "dex", pc));     //16
    }

    void updateSkills(String  arg){
        int i = 0, a = 0;
        if(arg.equals("str")) a = pc.scoreModifier(pc.getStr()) + (pc.getLvl() / 2);
        else if(arg.equals("con")) a = pc.scoreModifier(pc.getCon()) + (pc.getLvl() / 2);
        else if(arg.equals("dex")) a = pc.scoreModifier(pc.getDex()) + (pc.getLvl() / 2);
        else if(arg.equals("int")) a = pc.scoreModifier(pc.getInte()) + (pc.getLvl() / 2);
        else if(arg.equals("wis")) a = pc.scoreModifier(pc.getWis()) + (pc.getLvl() / 2);
        else if(arg.equals("cha")) a = pc.scoreModifier(pc.getCha()) + (pc.getLvl() / 2);
        while(i < 17){
            if(arg.equals(pc.getSkill(i).getAbilityModName())) pc.getSkill(i).setAbilityMod(a);
            i ++;
        }
    }
    void defineClass() {
        purgeSkills();
        if (pc.getClas().equals("Cleric")) {
            setTrained("Religion");
            pc.setKnowedSkills("Religion", 0);
            pc.setMaxSkills(3);
            setEditable("Arcana");
            setEditable("Diplomacy");
            setEditable("Heal");
            setEditable("History");
            setEditable("Insight");
        } else if (pc.getClas().equals("Fighter")) {
            pc.setMaxSkills(3);
            setEditable("Athletics");
            setEditable("Endurance");
            setEditable("Heal");
            setEditable("Intimidate");
            setEditable("Streetwise");
        } else if (pc.getClas().equals("Paladin")) {
            pc.setMaxSkills(3);
        } else if (pc.getClas().equals("Ranger")) {
            if (pc.getExtraClassStads().get(1).equals("Dungeoneering")) {
                setTrained("Dungeoneering");
                pc.setKnowedSkills("Dungeoneering", 0);
            } else if (pc.getExtraClassStads().get(1).equals("Nature")) {
                setTrained("Nature");
                pc.setKnowedSkills("Nature", 0);
            }
            pc.setMaxSkills(4);
        } else if (pc.getClas().equals("Rouge")) {
            setTrained("Stealth");
            pc.setKnowedSkills("Stealth" ,0);
            setTrained("Thievery");
            pc.setKnowedSkills("Thievery" ,0);
            pc.setMaxSkills(4);
            setEditable("Acrobatics");
            setEditable("Athelics");
            setEditable("Bluff");
            setEditable("Dungeoneering");
            setEditable("Insight");
            setEditable("Intimidate");
            setEditable("Perception");
            setEditable("Streetwise");
        } else if (pc.getClas().equals("Warlord")) {
            pc.setMaxSkills(4);
            setEditable("Athletics");
            setEditable("Diplomacy");
            setEditable("Endurance");
            setEditable("Heal");
            setEditable("History");
            setEditable("Intimidate");
        } else if (pc.getClas().equals("Warlock")) {
            pc.setMaxSkills(4);
        } else if (pc.getClas().equals("Wizard")) {
            setTrained("Arcana");
            pc.setKnowedSkills("Arcana" ,0);
            pc.setMaxSkills(3);
            setEditable("Diplomacy");
            setEditable("Dungeoneering");
            setEditable("History");
            setEditable("Insight");
            setEditable("Nature");
            setEditable("Religion");
        }
    }

    void defineSkills() {
        defineClass();
        if (pc.getRace().equals("Dragonborn")) {
        } else if (pc.getRace().equals("Dwarf")) {
        } else if (pc.getRace().equals("Eladrin")) {
            pc.setMaxSkills(pc.getMaxSkills() + 1);
        } else if (pc.getRace().equals("Elf")) {
        } else if (pc.getRace().equals("Half-elf")) {
        } else if (pc.getRace().equals("Halfling")) {
        } else if (pc.getRace().equals("Human")) {
        } else if (pc.getRace().equals("Tiefling")) {
            setMiscelaneous("Bluff", 2);
            setMiscelaneous("History", 2);
        }
    }

    public int getBonus() {
        return abilityMod + trained + armorPenality + miscelanious;
    }

    public String getAbilityModName() {
        return abilityModName;
    }

    public void setAbilityModName(String abilityModName) {
        this.abilityModName = abilityModName;
    }

    public PlayerCharacter getPc() {
        return pc;
    }

    public void setPc(PlayerCharacter pc) {
        this.pc = pc;
    }

    public void setAbilityMod(int abilityMod) {
        this.abilityMod = abilityMod;
    }

}