/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package program.gui.control;

import data.Game;
import gameRules.PlayerCharacter;
import program.gui.Frame;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;

/**
 *
 * @author dfoxpro
 */
public class Control {

    private PlayerCharacter pc;
    private Frame frame;
    private boolean hoseruled;
    private boolean manualScore;
    private boolean l76;

    /**
     * Hola mundo
     */
    public Control(Game data) {
        try {
            // Set System L&F
            UIManager.setLookAndFeel(
                    UIManager.getSystemLookAndFeelClassName());
        } catch (UnsupportedLookAndFeelException e) {
            // handle exception
            // UIManager.setLookAndFeel(
            //UIManager.get);
        } catch (ClassNotFoundException e) {
            // handle exception
        } catch (InstantiationException e) {
            // handle exception
        } catch (IllegalAccessException e) {
            // handle exception
        }
//        pj.setLvl( 30);
        frame = new Frame(this); //Create and show the GUI
        frame.setVisible(true);
    }

    //Inicia el jugador
    public void initPCGui() {
        pc = new PlayerCharacter();
        frame.gettName().setVisible(true);
        frame.getbNext6().setEnabled(true);
        frame.getjLabel1().setText("<html><center><h3>1º Select your name</h3></center>");
    }

    public void changeName() {
        String s = frame.gettName().getText();
        boolean b = true;
        if (s.equals("Name")) {
            frame.getjLabel1().setText("<html><center><h3>1º Select your name</h3></center>");
            b = false;
        } else {
            pc.setName(s);
            showPjInfo();
            frame.getjLabel1().setText("<html><center><h3>1º Select your race</h3></center>");
        }
        if (b) {
            frame.getTpPj().setSelectedIndex(frame.getTpBuild().getSelectedIndex() + 1);
        }
    }

    public boolean changeRace() {
        // TODO A corregiur: sacar las reglas de este metodo: race
        String s = frame.getcRace().getItemAt(frame.getcRace().getSelectedIndex()).toString();

        boolean b = true;
        if (s.equals("RACE")) {
            frame.getjLabel1().setText("<html><center><h3>1º Select your race</h3></center>");
            b = false;
        } else {
            pc.setRace(s);
            showPjInfo();
            if (s.equals("Human")) {
                frame.getjLabel1().setText("<html><center><h3>1.1 Select your Ability score</h3></center>");
                frame.getcHAS1().setVisible(true);
                frame.getpDragonBorn().setVisible(false);
                b = false;
            } else if (s.equals("Dragonborn")) {
                frame.getjLabel1().setText("<html><center><h3>1.1 Select your \"Dragon  Breath key ability\"</h3></center>");
                frame.getpDragonBorn().setVisible(true);
                frame.getcHAS1().setVisible(false);
                b = false;
            } else {
                frame.getpDragonBorn().setVisible(false);
                frame.getcHAS1().setVisible(false);
            }
            frame.getjLabel1().setText("<html><center><h3>2º Select your gender</h3></center>");
            frame.getcLanguaje().setVisible(false);
        }
        return b;
    }

    public boolean changeDragonBreath(int i) {
        // TODO A corregiur: sacar las reglas de este metodo: race
        String s = frame.getcDBKA().getItemAt(frame.getcDBKA().getSelectedIndex()).toString();

        boolean b = true;
        if (i == 0) {
            if (s.equals("Key ability")) {
                frame.getjLabel1().setText("<html><center><h3>1.1 Select your \"Dragon  Breath key ability\"</h3></center>");
                b = false;
            } else {
                pc.setExtraRaceStads(0, s);
                frame.getjLabel1().setText("<html><center><h3>1.2 Select your \"Dragon  Breath damage type\"</h3></center>");
            }
        } else if (i == 1) {
            if (s.equals("Damage type")) {
                frame.getjLabel1().setText("<html><center><h3>1.2 Select your \"Dragon  Breath damage type\"</h3></center>");
                b = false;
            } else {
                pc.setExtraRaceStads(1, s);
                frame.getjLabel1().setText("<html><center><h3>2º Select your gender</h3></center>");
            }
        }
        return b;
    }

    public boolean changeHAS() {
        // TODO: A corregiur: sacar las reglas de este metodo: race
        //HUMAN ABILITY SCORE
        boolean b = true;
        String s = frame.getcHAS1().getItemAt(frame.getcHAS1().getSelectedIndex()).toString();
        if (s.equals("Ability score")) {
            frame.getjLabel1().setText("<html><center><h3>1.1 Select your Ability score</h3></center>");
            b = false;
        } else {
            pc.setHAS(s);
            scoreChangeStr();
            scoreChangeCon();
            scoreChangeDex();
            scoreChangeInt();
            scoreChangeWis();
            scoreChangeCha();
            showPjInfo();
            frame.getjLabel1().setText("<html><center><h3>2º Select your gender</h3></center>");
        }
        return b;
    }

    public boolean changeGender() {
        // TODO: A corregiur: sacar las reglas de este metodo: pj
        String s = frame.getcGender().getItemAt(frame.getcGender().getSelectedIndex()).toString();

        boolean b = true;
        if (s.equals("GENDER")) {
            frame.getjLabel1().setText("<html><center><h3>2º Select your gender</h3></center>");
            b = false;
        } else {
            pc.setGender(s);
            showPjInfo();

            if (pc.getLanguajes().get(0).equals("1")) {
                frame.getjLabel1().setText("<html><center><h3>2.1 Select your 2º languaje</h3></center>");
                frame.getcLanguaje().setVisible(true);
                b = false;
            } else {
                frame.getcLanguaje().setVisible(false);
                frame.getjLabel1().setText("<html><center><h3>3º Select your class</h3></center>");
            }
        }

        return b;
    }

    public boolean change2ndLanguaje() {
        // TODO: A corregiur: sacar las reglas de este metodo: pj
        boolean b = true;
        String s = frame.getcLanguaje().getItemAt(frame.getcLanguaje().getSelectedIndex()).toString();
        if (s.equals("Common")) {
            frame.getjLabel1().setText("<html><center><h3>2.1 Select your 2º languaje</h3></center>");
            b = false;
        } else {
            pc.set2ndLanguaje(s);
            showPjInfo();
            frame.getjLabel1().setText("<html><center><h3>3º Select your class</h3></center>");
        }
        return b;
    }

    public boolean changeClass() {
        // TODO: A corregiur: sacar las reglas de este metodo: Class
        String s = frame.getcClass().getItemAt(frame.getcClass().getSelectedIndex()).toString();
        boolean b = true;
        if (s.equals("CLASS")) {
            pc.setClas("");
            frame.getjLabel1().setText("<html><center><h3>3º Select your class</h3></center>");
            frame.getcFtV().setVisible(false);
            frame.getpRaV().setVisible(false);
            frame.getcRoV().setVisible(false);
            frame.getcWldV().setVisible(false);
            frame.getcWlkV().setVisible(false);
            frame.getcWzdV().setVisible(false);
            b = false;
        } else if (s.equals("Fighter")) {
            pc.setClas(s);
            frame.getjLabel1().setText("<html><center><h3>3.1 Select your fighter weapon talent</h3></center>");
            frame.getcFtV().setVisible(true);
            frame.getpRaV().setVisible(false);
            frame.getcRoV().setVisible(false);
            frame.getcWldV().setVisible(false);
            frame.getcWlkV().setVisible(false);
            frame.getcWzdV().setVisible(false);
            b = false;
        } else if (s.equals("Ranger")) {
            pc.setClas(s);
            frame.getjLabel1().setText("<html><center><h3>3.1 Select your ranger fighting style</h3></center>");
            frame.getcFtV().setVisible(false);
            frame.getpRaV().setVisible(true);
            frame.getcRoV().setVisible(false);
            frame.getcWldV().setVisible(false);
            frame.getcWlkV().setVisible(false);
            frame.getcWzdV().setVisible(false);
            b = false;
        } else if (s.equals("Rouge")) {
            pc.setClas(s);
            frame.getjLabel1().setText("<html><center><h3>3.1 Select your rouge tactic</h3></center>");
            frame.getcFtV().setVisible(false);
            frame.getpRaV().setVisible(false);
            frame.getcRoV().setVisible(true);
            frame.getcWldV().setVisible(false);
            frame.getcWlkV().setVisible(false);
            frame.getcWzdV().setVisible(false);
            b = false;
        } else if (s.equals("Warlord")) {
            pc.setClas(s);

            frame.getjLabel1().setText("<html><center><h3>3.1 Select your warlord commanding presence</h3></center>");
            frame.getcFtV().setVisible(false);
            frame.getpRaV().setVisible(false);
            frame.getcRoV().setVisible(false);
            frame.getcWldV().setVisible(true);
            frame.getcWlkV().setVisible(false);
            frame.getcWzdV().setVisible(false);
            b = false;
        } else if (s.equals("Warlock")) {
            pc.setClas(s);

            frame.getjLabel1().setText("<html><center><h3>3.1 Select your warlock eldritch pact</h3></center>");
            frame.getcFtV().setVisible(false);
            frame.getpRaV().setVisible(false);
            frame.getcRoV().setVisible(false);
            frame.getcWldV().setVisible(false);
            frame.getcWlkV().setVisible(true);
            frame.getcWzdV().setVisible(false);
            b = false;
        } else if (s.equals("Wizard")) {
            pc.setClas(s);

            frame.getjLabel1().setText("<html><center><h3>3.1 Select your wizard arcane implement maestry</h3></center>");
            frame.getcFtV().setVisible(false);
            frame.getpRaV().setVisible(false);
            frame.getcRoV().setVisible(false);
            frame.getcWldV().setVisible(false);
            frame.getcWlkV().setVisible(false);
            frame.getcWzdV().setVisible(true);
            b = false;
        } else {
            pc.setClas(s);
            pc.setSkills();
            initSkillGui();
            frame.getcFtV().setVisible(false);
            frame.getpRaV().setVisible(false);
            frame.getcRoV().setVisible(false);
            frame.getcWldV().setVisible(false);
            frame.getcWlkV().setVisible(false);
            frame.getcWzdV().setVisible(false);
            frame.getjLabel1().setText("<html><center><h3>4º Select your Alignment</h3></center>");
        }
        changeSkill();
        return b;
    }

    public boolean changeClassFeature(int i) {
        // TODO: A corregiur: sacar las reglas de este metodo: Class
        boolean b = true;
        if (i == 1) {
            String s = frame.getcFtV().getItemAt(frame.getcFtV().getSelectedIndex()).toString();
            if (s.equals("Fighter weapon talent")) {
                frame.getjLabel1().setText("<html><center><h3>3.1 Select your fighter weapon talent</h3></center>");
                b = false;
            } else {
                pc.setExtraClassStads(0, s);
                showPjInfo();
            }
        } else if (i == 2) {
            String s = frame.getcRaV().getItemAt(frame.getcRaV().getSelectedIndex()).toString();
            if (s.equals("Ranger fighting style")) {
                frame.getjLabel1().setText("<html><center><h3>3.1 Select your ranger fighting style</h3></center>");
                b = false;
            } else {
                pc.setExtraClassStads(0, s);
                showPjInfo();
                frame.getjLabel1().setText("<html><center><h3>3.2 Select your ranger trained class</h3></center>");
                frame.getcRaSk().setEnabled(true);
                return false;
            }
        } else if (i == 3) {
            String s = frame.getcRoV().getItemAt(frame.getcRoV().getSelectedIndex()).toString();
            if (s.equals("Rouge Tactics")) {
                frame.getjLabel1().setText("<html><center><h3>3.1 Select your Rouge Tactics</h3></center>");
                b = false;
            } else {
                pc.setExtraClassStads(0, s);
                showPjInfo();
            }
        } else if (i == 4) {
            String s = frame.getcWlkV().getItemAt(frame.getcWlkV().getSelectedIndex()).toString();
            if (s.equals("Warlock Eldritch pact")) {
                frame.getjLabel1().setText("<html><center><h3>3.1 Select your Warlock Eldritch pact</h3></center>");
                b = false;
            } else {
                pc.setExtraClassStads(0, s);
                showPjInfo();
            }
        } else if (i == 5) {
            String s = frame.getcWldV().getItemAt(frame.getcWldV().getSelectedIndex()).toString();
            if (s.equals("Warlord commanding presence")) {
                frame.getjLabel1().setText("<html><center><h3>3.1 Select your Warlord commanding presence</h3></center>");
                b = false;
            } else {
                pc.setExtraClassStads(0, s);
                showPjInfo();
            }
        } else if (i == 6) {
            String s = frame.getcWzdV().getItemAt(frame.getcWzdV().getSelectedIndex()).toString();
            if (s.equals("Wizard Arcane implement mastery")) {
                frame.getjLabel1().setText("<html><center><h3>3.1 Select your Wizard Arcane implement mastery</h3></center>");
                b = false;
            } else {
                pc.setExtraClassStads(0, s);
                showPjInfo();
            }
        }
        if (b) {
            frame.getjLabel1().setText("<html><center><h3>4º Select your Alignment</h3></center>");
        }
        pc.setSkills();
        initSkillGui();
        return b;
    }

    public boolean changeRangerSkill() {
        // TODO: A corregiur: sacar las reglas de este metodo: Class
        boolean b = true;
        String s = frame.getcRaSk().getItemAt(frame.getcRaSk().getSelectedIndex()).toString();
        if (s.equals("Ranger trained class")) {
            frame.getjLabel1().setText("<html><center><h3>3.2 Select your ranger trained class</h3></center>");
            b = false;
        } else {
            pc.setExtraClassStads(1, s);
            pc.setSkills();
            initSkillGui();
            changeSkill();
            frame.getjLabel1().setText("<html><center><h3>4º Select your Alignment</h3></center>");
        }
        return b;

    }

    public boolean changeAling() {
        // TODO: A corregiur: sacar las reglas de este metodo: pj
        boolean b = true;
        String s = frame.getcAlignment().getItemAt(frame.getcAlignment().getSelectedIndex()).toString();
        if (s.equals("Alignment")) {
            frame.getjLabel1().setText("<html><center><h3>4º Select your Alignment</h3></center>");
            b = false;
        } else {
            pc.setAlignment(s);
            showPjInfo();
            frame.getjLabel1().setText("<html><center><h3>5º Select your Deity</h3></center>");
        }
        return b;
    }

    public boolean changeDeity() {
        // TODO: A corregiur: sacar las reglas de este metodo: pj
        boolean b = true;
        String s = frame.getcDeity().getItemAt(frame.getcDeity().getSelectedIndex()).toString();
        if (s.equals("Deity")) {
            frame.getjLabel1().setText("<html><center><h3>5º Select your Deity</h3></center>");
            b = false;
        } else {
            pc.setDeity(s);
            showPjInfo();
            frame.getjLabel1().setText("<html><center><h3>6º Select your ability scores</h3></center>");
        }
        return b;
    }

    public void scoreChangeStr() {
        int b, a = (Integer) frame.getsSTR().getValue() + pc.getBnStr();
        pc.setStr(a);
        b = pc.scoreModifier(a);

        frame.getAmSTR().setText("" + b);
        frame.getmSTR().setText("" + (b + (pc.getLvl() / 2)));
        frame.getlSTR().setText(scoreText(a, "strengh", "STR"));
    }

    public void scoreChangeCon() {
        int b, a = (Integer) frame.getsCON().getValue() + pc.getBnCon();
        pc.setCon(a);
        b = pc.scoreModifier(a);

        frame.getAmCON().setText("" + b);
        frame.getmCON().setText("" + (b + (pc.getLvl() / 2)));
        frame.getlCON().setText(scoreText(a, "constitution", "CON"));
    }

    public void scoreChangeDex() {
        int b, a = (Integer) frame.getsDEX().getValue() + pc.getBnDex();
        pc.setDex(a);
        b = pc.scoreModifier(a);
        frame.getAmDEX().setText("" + b);
        frame.getmDEX().setText("" + (b + (pc.getLvl() / 2)));
        frame.getlDEX().setText(scoreText(a, "dexterity", "DEX"));
    }

    public void scoreChangeInt() {
        int b, a = (Integer) frame.getsINT().getValue() + pc.getBnInt();
        pc.setInte(a);
        b = pc.scoreModifier(a);
        frame.getAmINT().setText("" + b);
        frame.getmINT().setText("" + (b + (pc.getLvl() / 2)));
        frame.getlINT().setText(scoreText(a, "inteligence", "INT"));
    }

    public void scoreChangeWis() {
        int b, a = (Integer) frame.getsWIS().getValue() + pc.getBnWis();
        pc.setWis(a);
        b = pc.scoreModifier(a);
        frame.getAmWIS().setText("" + b);
        frame.getmWIS().setText("" + (b + (pc.getLvl() / 2)));
        frame.getlWIS().setText(scoreText(a, "wisdow", "WIS"));
    }

    public void scoreChangeCha() {
        int b, a = (Integer) frame.getsCHA().getValue() + pc.getBnCha();
        pc.setCha(a);
        b = pc.scoreModifier(a);
        frame.getAmCHA().setText("" + b);
        frame.getmCHA().setText("" + (b + (pc.getLvl() / 2)));
        frame.getlCHA().setText(scoreText(a, "charisma", "CHA"));
    }

    public void scoreHouseRule() {
        // TODO: A corregiur: sacar las reglas de este metodo: pj
        hoseruled = true;
        manualScore = false;
    }

    public void scoreManual() {
        // TODO: A corregiur: sacar las reglas de este metodo: pj
        hoseruled = true;
        manualScore = true;
    }

    public int sumScores() {
        int i = (Integer) frame.getsSTR().getValue();
        i += (Integer) frame.getsCON().getValue();
        i += (Integer) frame.getsDEX().getValue();
        i += (Integer) frame.getsINT().getValue();
        i += (Integer) frame.getsWIS().getValue();
        i += (Integer) frame.getsCHA().getValue();
        return i;
    }

    public void initSkillGui() {
        pc.setSkills();
        frame.getCbSkillAcro().setSelected(pc.getSkill(0).getTrained() > 0);
        frame.getCbSkillArca().setSelected(pc.getSkill(1).getTrained() > 0);
        frame.getCbSkillAthl().setSelected(pc.getSkill(2).getTrained() > 0);
        frame.getCbSkillBluf().setSelected(pc.getSkill(3).getTrained() > 0);
        frame.getCbSkillDipl().setSelected(pc.getSkill(4).getTrained() > 0);
        frame.getCbSkillDung().setSelected(pc.getSkill(5).getTrained() > 0);
        frame.getCbSkillEndu().setSelected(pc.getSkill(6).getTrained() > 0);
        frame.getCbSkillHeal().setSelected(pc.getSkill(7).getTrained() > 0);
        frame.getCbSkillHist().setSelected(pc.getSkill(8).getTrained() > 0);
        frame.getCbSkillInsi().setSelected(pc.getSkill(9).getTrained() > 0);
        frame.getCbSkillInti().setSelected(pc.getSkill(10).getTrained() > 0);
        frame.getCbSkillNatu().setSelected(pc.getSkill(11).getTrained() > 0);
        frame.getCbSkillPerc().setSelected(pc.getSkill(12).getTrained() > 0);
        frame.getCbSkillReli().setSelected(pc.getSkill(13).getTrained() > 0);
        frame.getCbSkillStea().setSelected(pc.getSkill(14).getTrained() > 0);
        frame.getCbSkillStre().setSelected(pc.getSkill(15).getTrained() > 0);
        frame.getCbSkillThie().setSelected(pc.getSkill(16).getTrained() > 0);
    }

    public void changeSkill() {
        int j = pc.getMaxSkills();

        if (!pc.getKnowedSkills(0).equals(pc.getSkill(0).getName())) {
            if (!pc.getKnowedSkills(1).equals(pc.getSkill(0).getName())) {
                if (frame.getCbSkillAcro().isSelected()) {
                    pc.getSkill(0).setTrained(5);
                    j--;
                } else {
                    pc.getSkill(0).setTrained(0);
                }
            }
        }
        if (!pc.getKnowedSkills(0).equals(pc.getSkill(1).getName())) {
            if (!pc.getKnowedSkills(1).equals(pc.getSkill(1).getName())) {
                if (frame.getCbSkillArca().isSelected()) {
                    pc.getSkill(1).setTrained(5);
                    j--;
                }
            } else {
                pc.getSkill(1).setTrained(0);
            }
        }
        if (!pc.getKnowedSkills(0).equals(pc.getSkill(2).getName())) {
            if (!pc.getKnowedSkills(1).equals(pc.getSkill(2).getName())) {
                if (frame.getCbSkillAthl().isSelected()) {
                    pc.getSkill(2).setTrained(5);
                    j--;
                }
            } else {
                pc.getSkill(2).setTrained(0);
            }
        }
        if (!pc.getKnowedSkills(0).equals(pc.getSkill(3).getName())) {
            if (!pc.getKnowedSkills(1).equals(pc.getSkill(3).getName())) {
                if (frame.getCbSkillBluf().isSelected()) {
                    pc.getSkill(3).setTrained(5);
                    j--;
                }
            } else {
                pc.getSkill(3).setTrained(0);
            }
        }
        if (!(pc.getKnowedSkills(0).equals(pc.getSkill(4).getName())) | !(pc.getKnowedSkills(1).equals(pc.getSkill(4).getName()))) {
            if (frame.getCbSkillDipl().isSelected()) {
                pc.getSkill(4).setTrained(5);
                j--;
            } else {
                pc.getSkill(4).setTrained(0);
            }
        }
        if (!(pc.getKnowedSkills(0).equals(pc.getSkill(5).getName())) | !(pc.getKnowedSkills(1).equals(pc.getSkill(5).getName()))) {
            if (frame.getCbSkillDung().isSelected()) {
                pc.getSkill(5).setTrained(5);
                j--;
            } else {
                pc.getSkill(5).setTrained(0);
            }
        }
        if (!(pc.getKnowedSkills(0).equals(pc.getSkill(6).getName())) | !(pc.getKnowedSkills(1).equals(pc.getSkill(6).getName()))) {
            if (frame.getCbSkillEndu().isSelected()) {
                pc.getSkill(6).setTrained(5);
                j--;
            } else {
                pc.getSkill(6).setTrained(0);
            }
        }
        if (!(pc.getKnowedSkills(0).equals(pc.getSkill(7).getName())) | !(pc.getKnowedSkills(1).equals(pc.getSkill(7).getName()))) {
            if (frame.getCbSkillHeal().isSelected()) {
                pc.getSkill(7).setTrained(5);
                j--;
            } else {
                pc.getSkill(7).setTrained(0);
            }
        }
        if (!(pc.getKnowedSkills(0).equals(pc.getSkill(8).getName())) | !(pc.getKnowedSkills(1).equals(pc.getSkill(8).getName()))) {
            if (frame.getCbSkillHist().isSelected()) {
                pc.getSkill(8).setTrained(5);
                j--;
            } else {
                pc.getSkill(8).setTrained(0);
            }
        }
        if (!(pc.getKnowedSkills(0).equals(pc.getSkill(9).getName())) | !(pc.getKnowedSkills(1).equals(pc.getSkill(9).getName()))) {
            if (frame.getCbSkillInsi().isSelected()) {
                pc.getSkill(9).setTrained(5);
                j--;
            } else {
                pc.getSkill(9).setTrained(0);
            }
        }
        if (!(pc.getKnowedSkills(0).equals(pc.getSkill(10).getName())) | !(pc.getKnowedSkills(1).equals(pc.getSkill(10).getName()))) {
            if (frame.getCbSkillInti().isSelected()) {
                pc.getSkill(10).setTrained(5);
                j--;
            } else {
                pc.getSkill(10).setTrained(0);
            }
        }
        if (!(pc.getKnowedSkills(0).equals(pc.getSkill(11).getName())) | !(pc.getKnowedSkills(1).equals(pc.getSkill(11).getName()))) {
            if (frame.getCbSkillNatu().isSelected()) {
                pc.getSkill(11).setTrained(5);
                j--;
            } else {
                pc.getSkill(11).setTrained(0);
            }
        }
        if (!(pc.getKnowedSkills(0).equals(pc.getSkill(12).getName())) | !(pc.getKnowedSkills(1).equals(pc.getSkill(12).getName()))) {
            if (frame.getCbSkillPerc().isSelected()) {
                pc.getSkill(12).setTrained(5);
                j--;
            } else {
                pc.getSkill(12).setTrained(0);
            }
        }
        if (!(pc.getKnowedSkills(0).equals(pc.getSkill(13).getName())) | !(pc.getKnowedSkills(1).equals(pc.getSkill(13).getName()))) {
            if (frame.getCbSkillReli().isSelected()) {
                pc.getSkill(13).setTrained(5);
                j--;
            } else {
                pc.getSkill(13).setTrained(0);
            }
        }
        if (!(pc.getKnowedSkills(0).equals(pc.getSkill(14).getName())) | !(pc.getKnowedSkills(1).equals(pc.getSkill(14).getName()))) {
            if (frame.getCbSkillStea().isSelected()) {
                pc.getSkill(14).setTrained(5);
                j--;
            } else {
                pc.getSkill(14).setTrained(0);
            }
        }
        if (!(pc.getKnowedSkills(0).equals(pc.getSkill(15).getName())) | !(pc.getKnowedSkills(1).equals(pc.getSkill(15).getName()))) {
            if (frame.getCbSkillStre().isSelected()) {
                pc.getSkill(15).setTrained(5);
                j--;
            } else {
                pc.getSkill(15).setTrained(0);
            }
        }
        if (!(pc.getKnowedSkills(0).equals(pc.getSkill(16).getName())) | !(pc.getKnowedSkills(1).equals(pc.getSkill(16).getName()))) {
            if (frame.getCbSkillThie().isSelected()) {
                pc.getSkill(16).setTrained(5);
                j--;
            } else {
                pc.getSkill(16).setTrained(0);
            }
        }

        showPjInfo();
        if (j == 0) {
            if (!pc.getKnowedSkills(0).equals(pc.getSkill(0).getName())) {
                if (!pc.getKnowedSkills(1).equals(pc.getSkill(0).getName())) {
                    if (!frame.getCbSkillAcro().isSelected()) {
                        frame.getCbSkillAcro().setEnabled(false);
                    }
                }
            }
            if (!pc.getKnowedSkills(0).equals(pc.getSkill(1).getName())) {
                if (!pc.getKnowedSkills(1).equals(pc.getSkill(1).getName())) {
                    if (!frame.getCbSkillArca().isSelected()) {
                        frame.getCbSkillArca().setEnabled(false);
                    }
                }
            }
            if (!pc.getKnowedSkills(0).equals(pc.getSkill(2).getName())) {
                if (!pc.getKnowedSkills(1).equals(pc.getSkill(2).getName())) {
                    if (!frame.getCbSkillAthl().isSelected()) {
                        frame.getCbSkillAthl().setEnabled(false);
                    }
                }
            }
            if (!pc.getKnowedSkills(0).equals(pc.getSkill(3).getName())) {
                if (!pc.getKnowedSkills(1).equals(pc.getSkill(3).getName())) {
                    if (!frame.getCbSkillBluf().isSelected()) {
                        frame.getCbSkillBluf().setEnabled(false);
                    }
                }
            }
            if (!pc.getKnowedSkills(0).equals(pc.getSkill(4).getName())) {
                if (!pc.getKnowedSkills(1).equals(pc.getSkill(4).getName())) {
                    if (!frame.getCbSkillDipl().isSelected()) {
                        frame.getCbSkillDipl().setEnabled(false);
                    }
                }
            }
            if (!pc.getKnowedSkills(0).equals(pc.getSkill(5).getName())) {
                if (!pc.getKnowedSkills(1).equals(pc.getSkill(5).getName())) {
                    if (!frame.getCbSkillDung().isSelected()) {
                        frame.getCbSkillDung().setEnabled(false);
                    }
                }
            }
            if (!pc.getKnowedSkills(0).equals(pc.getSkill(6).getName())) {
                if (!pc.getKnowedSkills(1).equals(pc.getSkill(6).getName())) {
                    if (!frame.getCbSkillEndu().isSelected()) {
                        frame.getCbSkillEndu().setEnabled(false);
                    }
                }
            }
            if (!pc.getKnowedSkills(0).equals(pc.getSkill(7).getName())) {
                if (!pc.getKnowedSkills(1).equals(pc.getSkill(7).getName())) {
                    if (!frame.getCbSkillHeal().isSelected()) {
                        frame.getCbSkillHeal().setEnabled(false);
                    }
                }
            }
            if (!pc.getKnowedSkills(0).equals(pc.getSkill(8).getName())) {
                if (!pc.getKnowedSkills(1).equals(pc.getSkill(8).getName())) {
                    if (!frame.getCbSkillHist().isSelected()) {
                        frame.getCbSkillHist().setEnabled(false);
                    }
                }
            }
            if (!pc.getKnowedSkills(0).equals(pc.getSkill(9).getName())) {
                if (!pc.getKnowedSkills(1).equals(pc.getSkill(9).getName())) {
                    if (!frame.getCbSkillInsi().isSelected()) {
                        frame.getCbSkillInsi().setEnabled(false);
                    }
                }
            }
            if (!pc.getKnowedSkills(0).equals(pc.getSkill(10).getName())) {
                if (!pc.getKnowedSkills(1).equals(pc.getSkill(10).getName())) {
                    if (!frame.getCbSkillInti().isSelected()) {
                        frame.getCbSkillInti().setEnabled(false);
                    }
                }
            }
            if (!pc.getKnowedSkills(0).equals(pc.getSkill(11).getName())) {
                if (!pc.getKnowedSkills(1).equals(pc.getSkill(11).getName())) {
                    if (!frame.getCbSkillNatu().isSelected()) {
                        frame.getCbSkillNatu().setEnabled(false);
                    }
                }
            }
            if (!pc.getKnowedSkills(0).equals(pc.getSkill(12).getName())) {
                if (!pc.getKnowedSkills(1).equals(pc.getSkill(12).getName())) {
                    if (!frame.getCbSkillPerc().isSelected()) {
                        frame.getCbSkillPerc().setEnabled(false);
                    }
                }
            }
            if (!pc.getKnowedSkills(0).equals(pc.getSkill(13).getName())) {
                if (!pc.getKnowedSkills(1).equals(pc.getSkill(13).getName())) {
                    if (!frame.getCbSkillReli().isSelected()) {
                        frame.getCbSkillReli().setEnabled(false);
                    }
                }
            }
            if (!pc.getKnowedSkills(0).equals(pc.getSkill(14).getName())) {
                if (!pc.getKnowedSkills(1).equals(pc.getSkill(14).getName())) {
                    if (!frame.getCbSkillStea().isSelected()) {
                        frame.getCbSkillStea().setEnabled(false);
                    }
                }
            }
            if (!pc.getKnowedSkills(0).equals(pc.getSkill(15).getName())) {
                if (!pc.getKnowedSkills(1).equals(pc.getSkill(15).getName())) {
                    if (!frame.getCbSkillStre().isSelected()) {
                        frame.getCbSkillStre().setEnabled(false);
                    }
                }
            }
            if (!pc.getKnowedSkills(0).equals(pc.getSkill(16).getName())) {
                if (!pc.getKnowedSkills(1).equals(pc.getSkill(16).getName())) {
                    if (!frame.getCbSkillThie().isSelected()) {
                        frame.getCbSkillThie().setEnabled(false);
                    }
                }
            }
        } else {

            frame.getCbSkillAcro().setEnabled(pc.getSkill(0).getEditable());
            frame.getCbSkillArca().setEnabled(pc.getSkill(1).getEditable());
            frame.getCbSkillAthl().setEnabled(pc.getSkill(2).getEditable());
            frame.getCbSkillBluf().setEnabled(pc.getSkill(3).getEditable());
            frame.getCbSkillDipl().setEnabled(pc.getSkill(4).getEditable());
            frame.getCbSkillDung().setEnabled(pc.getSkill(5).getEditable());
            frame.getCbSkillEndu().setEnabled(pc.getSkill(6).getEditable());
            frame.getCbSkillHeal().setEnabled(pc.getSkill(7).getEditable());
            frame.getCbSkillHist().setEnabled(pc.getSkill(8).getEditable());
            frame.getCbSkillInsi().setEnabled(pc.getSkill(9).getEditable());
            frame.getCbSkillInti().setEnabled(pc.getSkill(10).getEditable());
            frame.getCbSkillNatu().setEnabled(pc.getSkill(11).getEditable());
            frame.getCbSkillPerc().setEnabled(pc.getSkill(12).getEditable());
            frame.getCbSkillReli().setEnabled(pc.getSkill(13).getEditable());
            frame.getCbSkillStea().setEnabled(pc.getSkill(14).getEditable());
            frame.getCbSkillStre().setEnabled(pc.getSkill(15).getEditable());
            frame.getCbSkillThie().setEnabled(pc.getSkill(16).getEditable());
        }
        frame.getlSkill().setText("" + j + " avalible skills");
    }
    public String scoreText(int arg, String min, String may) {
        if (hoseruled & !manualScore) {
            frame.getsScoreTotal().setValue(sumScores());
        }
        return "<html><table border=\"0\" cellpadding=\"0\"cellspacing=\"0\"><tbody><tr><td rowspan=\"2\"><big><b>" + arg + "</b></big></td><td><small><b>" + may + "</b></small></td></tr><tr><td><small><small>" + min + "</small></small></td></tr></tbody></table><html>";
    }

    public void showPjInfo() {
        //TODO Skill list
        scoreChangeStr();
        scoreChangeCon();
        scoreChangeDex();
        scoreChangeInt();
        scoreChangeWis();
        scoreChangeCha();
        pc.upgradeSkills();

        frame.getlSAcro().setText("<html><table border=\"1\"><tbody><tr align=\"center\"><td width=\"39\">" + pc.getSkill(0).getAbilityModName() + "</td><td width=\"59\">" + pc.getSkill(0).getAbilityMod() + "</td><td width=\"54\">" + pc.getSkill(0).getArmorPenality() + "</td><td width=\"31\">" + pc.getSkill(0).getMiscelanious() + "</td><td width=\"42\"><b>" + pc.getSkills().get(0).getBonus() + "</b></td></tr></tbody></table>");
        frame.getlSArca().setText("<html><table border=\"1\"><tbody><tr align=\"center\"><td width=\"39\">" + pc.getSkill(1).getAbilityModName() + "</td><td width=\"59\">" + pc.getSkill(1).getAbilityMod() + "</td><td width=\"54\">--</td><td width=\"31\">" + pc.getSkill(1).getMiscelanious() + "</td><td width=\"42\"><b>" + pc.getSkills().get(1).getBonus() + "</b></td></tr></tbody></table>");
        frame.getlSAthl().setText("<html><table border=\"1\"><tbody><tr align=\"center\"><td width=\"39\">" + pc.getSkill(2).getAbilityModName() + "</td><td width=\"59\">" + pc.getSkill(2).getAbilityMod() + "</td><td width=\"54\">" + pc.getSkill(2).getArmorPenality() + "</td><td width=\"31\">" + pc.getSkill(2).getMiscelanious() + "</td><td width=\"42\"><b>" + pc.getSkills().get(2).getBonus() + "</b></td></tr></tbody></table>");
        frame.getlSBluf().setText("<html><table border=\"1\"><tbody><tr align=\"center\"><td width=\"39\">" + pc.getSkill(3).getAbilityModName() + "</td><td width=\"59\">" + pc.getSkill(3).getAbilityMod() + "</td><td width=\"54\">--</td><td width=\"31\">" + pc.getSkill(3).getMiscelanious() + "</td><td width=\"42\"><b>" + pc.getSkills().get(3).getBonus() + "</b></td></tr></tbody></table>");
        frame.getlSDipl().setText("<html><table border=\"1\"><tbody><tr align=\"center\"><td width=\"39\">" + pc.getSkill(4).getAbilityModName() + "</td><td width=\"59\">" + pc.getSkill(4).getAbilityMod() + "</td><td width=\"54\">--</td><td width=\"31\">" + pc.getSkill(4).getMiscelanious() + "</td><td width=\"42\"><b>" + pc.getSkills().get(4).getBonus() + "</b></td></tr></tbody></table>");
        frame.getlSDung().setText("<html><table border=\"1\"><tbody><tr align=\"center\"><td width=\"39\">" + pc.getSkill(5).getAbilityModName() + "</td><td width=\"59\">" + pc.getSkill(5).getAbilityMod() + "</td><td width=\"54\">--</td><td width=\"31\">" + pc.getSkill(5).getMiscelanious() + "</td><td width=\"42\"><b>" + pc.getSkills().get(5).getBonus() + "</b></td></tr></tbody></table>");
        frame.getlSEndu().setText("<html><table border=\"1\"><tbody><tr align=\"center\"><td width=\"39\">" + pc.getSkill(6).getAbilityModName() + "</td><td width=\"59\">" + pc.getSkill(6).getAbilityMod() + "</td><td width=\"54\">" + pc.getSkill(6).getArmorPenality() + "</td><td width=\"31\">" + pc.getSkill(6).getMiscelanious() + "</td><td width=\"42\"><b>" + pc.getSkills().get(6).getBonus() + "</b></td></tr></tbody></table>");
        frame.getlSHeal().setText("<html><table border=\"1\"><tbody><tr align=\"center\"><td width=\"39\">" + pc.getSkill(7).getAbilityModName() + "</td><td width=\"59\">" + pc.getSkill(7).getAbilityMod() + "</td><td width=\"54\">--</td><td width=\"31\">" + pc.getSkill(7).getMiscelanious() + "</td><td width=\"42\"><b>" + pc.getSkills().get(7).getBonus() + "</b></td></tr></tbody></table>");
        frame.getlSHist().setText("<html><table border=\"1\"><tbody><tr align=\"center\"><td width=\"39\">" + pc.getSkill(8).getAbilityModName() + "</td><td width=\"59\">" + pc.getSkill(8).getAbilityMod() + "</td><td width=\"54\">--</td><td width=\"31\">" + pc.getSkill(8).getMiscelanious() + "</td><td width=\"42\"><b>" + pc.getSkills().get(8).getBonus() + "</b></td></tr></tbody></table>");
        frame.getlSInsi().setText("<html><table border=\"1\"><tbody><tr align=\"center\"><td width=\"39\">" + pc.getSkill(9).getAbilityModName() + "</td><td width=\"59\">" + pc.getSkill(9).getAbilityMod() + "</td><td width=\"54\">--</td><td width=\"31\">" + pc.getSkill(9).getMiscelanious() + "</td><td width=\"42\"><b>" + pc.getSkills().get(9).getBonus() + "</b></td></tr></tbody></table>");
        frame.getlSInti().setText("<html><table border=\"1\"><tbody><tr align=\"center\"><td width=\"39\">" + pc.getSkill(10).getAbilityModName() + "</td><td width=\"59\">" + pc.getSkill(10).getAbilityMod() + "</td><td width=\"54\">--</td><td width=\"31\">" + pc.getSkill(10).getMiscelanious() + "</td><td width=\"42\"><b>" + pc.getSkills().get(10).getBonus() + "</b></td></tr></tbody></table>");
        frame.getlSNatu().setText("<html><table border=\"1\"><tbody><tr align=\"center\"><td width=\"39\">" + pc.getSkill(11).getAbilityModName() + "</td><td width=\"59\">" + pc.getSkill(11).getAbilityMod() + "</td><td width=\"54\">--</td><td width=\"31\">" + pc.getSkill(11).getMiscelanious() + "</td><td width=\"42\"><b>" + pc.getSkills().get(11).getBonus() + "</b></td></tr></tbody></table>");
        frame.getlSPerc().setText("<html><table border=\"1\"><tbody><tr align=\"center\"><td width=\"39\">" + pc.getSkill(12).getAbilityModName() + "</td><td width=\"59\">" + pc.getSkill(12).getAbilityMod() + "</td><td width=\"54\">--</td><td width=\"31\">" + pc.getSkill(12).getMiscelanious() + "</td><td width=\"42\"><b>" + pc.getSkills().get(12).getBonus() + "</b></td></tr></tbody></table>");
        frame.getlSReli().setText("<html><table border=\"1\"><tbody><tr align=\"center\"><td width=\"39\">" + pc.getSkill(13).getAbilityModName() + "</td><td width=\"59\">" + pc.getSkill(13).getAbilityMod() + "</td><td width=\"54\">--</td><td width=\"31\">" + pc.getSkill(13).getMiscelanious() + "</td><td width=\"42\"><b>" + pc.getSkills().get(13).getBonus() + "</b></td></tr></tbody></table>");
        frame.getlSSteal().setText("<html><table border=\"1\"><tbody><tr align=\"center\"><td width=\"39\">" + pc.getSkill(14).getAbilityModName() + "</td><td width=\"59\">" + pc.getSkill(14).getAbilityMod() + "</td><td width=\"54\">" + pc.getSkill(14).getArmorPenality() + "</td><td width=\"31\">" + pc.getSkill(14).getMiscelanious() + "</td><td width=\"42\"><b>" + pc.getSkills().get(14).getBonus() + "</b></td></tr></tbody></table>");
        frame.getlSStree().setText("<html><table border=\"1\"><tbody><tr align=\"center\"><td width=\"39\">" + pc.getSkill(15).getAbilityModName() + "</td><td width=\"59\">" + pc.getSkill(15).getAbilityMod() + "</td><td width=\"54\">--</td><td width=\"31\">" + pc.getSkill(15).getMiscelanious() + "</td><td width=\"42\"><b>" + pc.getSkills().get(15).getBonus() + "</b></td></tr></tbody></table>");
        frame.getlSThiev().setText("<html><table border=\"1\"><tbody><tr align=\"center\"><td width=\"39\">" + pc.getSkill(16).getAbilityModName() + "</td><td width=\"59\">" + pc.getSkill(16).getAbilityMod() + "</td><td width=\"54\">" + pc.getSkill(16).getArmorPenality() + "</td><td width=\"31\">" + pc.getSkill(16).getMiscelanious() + "</td><td width=\"42\"><b>" + pc.getSkills().get(16).getBonus() + "</b></td></tr></tbody></table>");

        String s = "";
        s += "<html>";
        s += "<table border=\"0\" cellpadding=\"1\" cellspacing=\"0\" bgcolor=\"#ffffff\" width=\"100%\"><tr align=\"center\">";
        s += "<td><h2>" + pc.getName() + "</h2></td><td><small>" + pc.getOwner() + "</small></td></tr>";
        s += "<tr align=\"center\"><td colspan=\"2\"><h3>Lvl: <b>" + pc.getLvl() + "</b>. <b>" + pc.getClas() + " " + pc.getRace() + "</b></h3></td></tr>";
        s += "<tr align=\"center\"><td colspan=\"2\"><p>Size: <b>" + pc.getSize() + "</b>; Age: <b>" + pc.getAge() + "</b>; Gender: <b>" + pc.getGender() +
                ";</b><br>Alignment: <b>" + pc.getAling() + "</b>; Deity: <b>" + pc.getDeity() +
                ";</b><br>Adventuring company: <b>" + pc.getAdventuringCompany() + "</b></p><br></td></tr></table>";
        s += "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" align=\"left\"><tr><td>";

        s += "<table border=\"1\" cellpadding=\"1\" cellspacing=\"0\" bgcolor=\"#ffffff\" align=\"left\"><tr align=\"center\">";
        s += "<td width=\"35\"><small>HP</small></td>" +
                "<td rowspan=\"2\" width=\"40\"> <big><big><b>" + pc.getStr() + "</b></big></big> </td><td rowspan=\"2\" width=\"40\"><b>STR</b></td>" +
                "<td width=\"40\"><small>Armor</small></td>";
        s += "</tr><tr align=\"center\"><td><b>" + pc.getMaxHp() + "</b></td><td><b>" + pc.getDefAC() + "</b></td></tr></table>";

        s += "<table border=\"1\" cellpadding=\"1\" cellspacing=\"0\" bgcolor=\"#ffffff\" align=\"left\"><tr align=\"center\">";
        s += "<td width=\"35\"><small>Init</small></td>" +
                "<td rowspan=\"2\" width=\"40\"> <big><big><b>" + pc.getCon() + "</b></big></big> </td><td rowspan=\"2\" width=\"40\"><b>CON</b></td>" +
                "<td width=\"40\"><small>Fort</small></td>";
        s += "</tr><tr align=\"center\"><td><b>" + pc.getInitiative() + "</b></td><td><b>" + pc.getDefFort() + "</b></td></tr></table><br>";

        s += "<table border=\"1\" cellpadding=\"1\" cellspacing=\"0\" bgcolor=\"#ffffff\" align=\"left\"><tr align=\"center\">";
        s += "<td width=\"35\"><small>SD</small></td>" +
                "<td rowspan=\"2\" width=\"40\"> <big><big><b>" + pc.getDex() + "</b></big></big> </td><td rowspan=\"2\" width=\"40\"><b>DEX</b></td>" +
                "<td width=\"40\"><small>Speed</small></td>";
        s += "</tr><tr align=\"center\"><td><b>" + pc.getSurgesPDay() + "</b></td><td><b>" + pc.getSpeed() + "</b></td></tr></table>";

        s += "<table border=\"1\" cellpadding=\"1\" cellspacing=\"0\" bgcolor=\"#ffffff\" align=\"left\"><tr align=\"center\">";
        s += "<td width=\"35\"><small>SD</small></td>" +
                "<td rowspan=\"2\" width=\"40\"> <big><big><b>" + pc.getInte() + "</b></big></big> </td><td rowspan=\"2\" width=\"40\"><b>INT</b></td>" +
                "<td width=\"40\"><small>Reflex</small></td>";
        s += "</tr><tr align=\"center\"><td><b>" + pc.getSurgesValue() + "</b></td><td><b>" + pc.getDefRef() + "</b></td></tr></table><br>";

        s += "<table border=\"1\" cellpadding=\"1\" cellspacing=\"0\" bgcolor=\"#ffffff\" align=\"left\"><tr align=\"center\">";
        s += "<td width=\"35\"><small>PI</small></td>" +
                "<td rowspan=\"2\" width=\"40\"> <big><big><b>" + pc.getWis() + "</b></big></big> </td><td rowspan=\"2\" width=\"40\"><b>WIS</b></td>" +
                "<td width=\"40\"><small>Act. P.</small></td>";
        s += "</tr><tr align=\"center\"><td><b>" + pc.getPassiveInsight() + "</b></td><td><b>" + pc.getActionPoints() + "</b></td></tr></table>";

        s += "<table border=\"1\" cellpadding=\"1\" cellspacing=\"0\" bgcolor=\"#ffffff\" align=\"left\"><tr align=\"center\">";
        s += "<td width=\"35\"><small>PP</small></td>" +
                "<td rowspan=\"2\" width=\"40\"> <big><big><b>" + pc.getCha() + "</b></big></big> </td><td rowspan=\"2\" width=\"40\"><b>CHA</b></td>" +
                "<td width=\"40\"><small>Will</small></td>";
        s += "</tr><tr align=\"center\"><td><b>" + pc.getPassivePerseption() + "</b></td><td><b>" + pc.getDefWill() + "</b></td></tr></table>";

        s += "</td><td>&nbsp;</td><td>";
        s += "<table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" align=\"right\">" +
                "<tr align=\"center\"><td width=\"30\">" + pc.getSkill(0).getBonus() + "</td><td width=\"50\">Acrob</td></tr>" +
                "<tr align=\"center\"><td width=\"30\">" + pc.getSkill(1).getBonus() + "</td><td width=\"50\">Arcan</td></tr>" +
                "<tr align=\"center\"><td width=\"30\">" + pc.getSkill(2).getBonus() + "</td><td width=\"50\">Athle</td></tr>" +
                "<tr align=\"center\"><td width=\"30\">" + pc.getSkill(3).getBonus() + "</td><td width=\"50\">Bluff</td></tr>" +
                "<tr align=\"center\"><td width=\"30\">" + pc.getSkill(4).getBonus() + "</td><td width=\"50\">Diplo</td></tr>" +
                "<tr align=\"center\"><td width=\"30\">" + pc.getSkill(5).getBonus() + "</td><td width=\"50\">Dunge</td></tr>" +
                "<tr align=\"center\"><td width=\"30\">" + pc.getSkill(6).getBonus() + "</td><td width=\"50\">Endur</td></tr>" +
                "<tr align=\"center\"><td width=\"30\">" + pc.getSkill(7).getBonus() + "</td><td width=\"50\">Heal</td></tr>" +
                "<tr align=\"center\"><td width=\"30\">" + pc.getSkill(8).getBonus() + "</td><td width=\"50\">Histo</td></tr>" +
                "<tr align=\"center\"><td width=\"30\">" + pc.getSkill(9).getBonus() + "</td><td width=\"60\">Insig</td></tr>" +
                "<tr align=\"center\"><td width=\"30\">" + pc.getSkill(10).getBonus() + "</td><td width=\"60\">Intim</td></tr>" +
                "<tr align=\"center\"><td width=\"30\">" + pc.getSkill(11).getBonus() + "</td><td width=\"60\">Natur</td></tr>" +
                "<tr align=\"center\"><td width=\"30\">" + pc.getSkill(12).getBonus() + "</td><td width=\"60\">Perce</td></tr>" +
                "<tr align=\"center\"><td width=\"30\">" + pc.getSkill(13).getBonus() + "</td><td width=\"60\">Relig</td></tr>" +
                "<tr align=\"center\"><td width=\"30\">" + pc.getSkill(14).getBonus() + "</td><td width=\"60\">Steal</td></tr>" +
                "<tr align=\"center\"><td width=\"30\">" + pc.getSkill(15).getBonus() + "</td><td width=\"60\">Stree</td></tr>" +
                "<tr align=\"center\"><td width=\"30\">" + pc.getSkill(16).getBonus() + "</td><td width=\"60\">Thieve</td></tr>" +
                "</table>";
        s += "</td></tr></table>";
        s += "<br><p>Languajes:" + pc.getLanguajes().get(1) + ", " + pc.getLanguajes().get(2) + "</p>";
        s += "<br><h3>Race features:</h3>";
        s += "<br><h3>Class / Path / Detiny features:</h3>";
        s += "<br><h3>Feats:</h3>";
        s += "</html>";
        frame.getjLabel2().setText(s);
    }
}