/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package program.persisten;

import data.Config;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author dfoxpro
 */
public class FileCheck {

    public void checkConf(Config config) {
        File fileConfig = new File("config.txt");
        //If file exist: Read the config file
        if (fileConfig.exists()) {
            try {
                Scanner scanner = new Scanner(fileConfig);
                //first use a Scanner to get each line
                while (scanner.hasNextLine()) {
                    String aLine = scanner.nextLine();
                    if (!aLine.startsWith("#")) {
                        config.setValue(aLine);
                    }
                }
            } catch (FileNotFoundException ex) {
                Logger.getLogger(FileCheck.class.getName()).log(Level.SEVERE, null, ex);
            }
        } //Write the config file
        else {
            config.setSavePath(fileConfig.getAbsoluteFile().getParent() + "/save/");
            config.setDataPath(fileConfig.getAbsoluteFile().getParent() + "/data/");
            String source = "#F-4D-CB Configuration file\n" + "version=" + config.getVersion() + "\n" + "fullscreen=" + config.isFullscreen() + "\n" + "dataPath=" + config.getDataPath() + "\n" + "savePath=" + config.getSavePath() + "\n" + "repositoryPath=" + config.getRepositoryPath() + "\n";
            try {
                FileWriter fwConfig = new FileWriter(fileConfig);
                fwConfig.write(source);
                fwConfig.close();
            } catch (IOException ex) {
                Logger.getLogger(FileCheck.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }

    public void checkData(Config config) {
        File fileData = new File(config.getDataPath() + "readme.txt");
        //If file exist: Check the data files
        if (fileData.exists()) {
            checkRaces(config);
            checkClases(config);
        }
        //Write the data folder file
        else {
            String source = "#F-4D-CB Configuration file\n#Please dnot delete it\n#put in this folder the *.db files\n";
            try {
                new File(config.getDataPath()).mkdir();
                FileWriter fwData = new FileWriter(fileData);
                fwData.write(source);
                fwData.close();
            } catch (IOException ex) {
                Logger.getLogger(FileCheck.class.getName()).log(Level.SEVERE, null, ex);
            }
            //TODO: An update algoritm to download the databases
        }
    }

    public void checkRaces(Config config) {
        //TODO: An algoritm to check this db
        File fileData = new File(config.getDataPath() + "races.db");
        //If file exist: Check the data files
        if (fileData.exists()) {
        } else{
            //TODO: An update algoritm to download this database
        }
    }

    private void checkClases(Config config) {
        //TODO: An algoritm to check this db
        File fileData = new File(config.getDataPath() + "clases.db");
        //If file exist: Check the data files
        if (fileData.exists()) {
        } else{
            //TODO: An update algoritm to download this database
        }
    }
}